<id>
Multiply Steps Rebuilds for YaBB 2.1
</id>

<version>
1.0
</version>

<mod info>
(ispired: http://www.yabbforum.com/community/YaBB.pl?num=1171726266)

To prevent server time-out due to the amount of data, rebuilding is split into multiple steps.
1 step ~ 30 second 
If it is not fitting to you, change $maxtime = 30 into $maxtime = xx in code ;)

This mod split 2 admin rebuild functions:
- rebuild memberlist
- rebuild memberhistory

Base on Y2.2 CVS, and a bit more.. ;)
In rebuilding, you see:
- how many member/topic found
- how many member/topic remaining of rebuilding
- run time of rebuilding
- remaining time of rebuilding

Tech info, compared with CVS code:
'Memcontinued' Output fixed.
Rebuild actition parameters removed. It's stored in workfile.
MAP replaced with FOREACH. It's a bit speedup, and use less memory.
Added: run time and remaining time of rebuilding

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
Admin/ModList.pl
Admin/Admin.pl
Languages/English/Admin.lng
</mod info>

<author>
Zoo
</author>

<homepage>

</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$rebuild_multiplysteps = "Multiply Steps Rebuild|Zoltan Kovacs (Zoo)|Memberlist and Memberhistory rebuilding are split into multiple steps.|1.0|26/02/07";
	push (@installed_mods, "$rebuild_multiplysteps");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
%rebuild_txt = (
 '1' => 'To prevent server time-out due to the amount of data, rebuilding is split into multiple steps.',
 '2' => 'If nothing happens in 5 seconds',
 '3' => 'click here to continue',
 '4' => 'Converting - please wait!', # Used in Javascript -- please test if you are using special characters
 '7' => '1 step ~',
 '8' => 'second',
 '9' => 'Run time:',
'10' => 'Time remaining:',
'11' => 'Members found:',
'12' => 'Members remaining: ',
'13' => 'Topic found:',
'14' => 'Topic remaining: '
);

</add before>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
sub RebuildMemList {
	&is_admin_or_gmod;
	&MemberIndex("rebuild");
	$yymain .= qq~<b>$admin_txt{'594'} $regcounter $admin_txt{'594a'}</b>~;
	$yytitle     = "$admin_txt{'593'}";
	$action_area = "rebuildmemlist";
	&AdminTemplate;
	exit;
}
</search for>

<replace>
sub RebuildMemList {
	my (@contents,$begin_time,$maxtime,$start_time,$timeleft,$hour,$min,$sec,$sumuser,$grpdel,$grpexist,$regtime,);

	# Security
	&is_admin_or_gmod;

	# Set up the multi-step action
	$maxtime = 30; # Time in seconds to spend
	$begin_time = CORE::time;
	
	if (-e "$memberdir/memberrest.txt.rebuild" ) {
		fopen(MEMBERREST, "$memberdir/memberrest.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberrest.txt.rebuild", 1);
		@contents = <MEMBERREST>;
		fclose(MEMBERREST);
		chomp @contents;

		fopen(MEMBERCALC, "$memberdir/membercalc.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/membercalc.txt.rebuild", 1);
		$start_time = <MEMBERCALC>;
		$sumuser = <MEMBERCALC>;
		fclose(MEMBERCALC);
		chomp ($begin_time,$numuser);
	}
	if (! @contents) {
		# Get the list
		opendir(MEMBERS, $memberdir) || die "$txt{'230'} ($memberdir) :: $!";
		@contents = grep { /\.vars$/ } readdir(MEMBERS);
		closedir(MEMBERS);

		fopen(MEMBERREST, ">$memberdir/memberrest.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberrest.txt.rebuild", 1);
		foreach my $member (@contents) {
			chomp $member;
			$member =~ s/\.vars$//;
			print MEMBERREST "$member\n" if $member;
		}		
		fclose(MEMBERREST);

		$sumuser = @contents;
		$start_time = $begin_time;
		fopen(MEMBERCALC, ">$memberdir/membercalc.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/membercalc.txt.rebuild", 1);
		print MEMBERCALC "$start_time\n";
		print MEMBERCALC "$sumuser\n";
		fclose(MEMBERCALC);

		$begin_time = +$maxtime; # only first step
	}

	# Loop through each -rest- member
	while (@contents) {
		$member = pop @contents;
		chomp $member;
		$grpdel   = 0;
		$grpexist = '';

		# Load the user's info
		&UserCheck($member, "realname+email+regdate+position+addgroups+postcount");
		(@addigroups) = split(/\,/, $usercheck{'addgroups'});
		foreach $addigrp (@addigroups) {
			if (!exists $NoPost{$addigrp}) { $grpdel = 1; }
			else { $grpexist .= qq~$addigrp,~; }
		}
		$actposition = $usercheck{'position'};
		if (!exists $Group{$actposition} && !exists $NoPost{$actposition}) {
			$usercheck{'position'} = "";
			$grpdel = 1;
		}
		if ($grpdel) {
			if (!${$uid.$member}{'password'}) { &LoadUser($member); }
			$grpexist =~ s/,\Z//;
			${$uid.$member}{'addgroups'} = qq~$grpexist~;
			${$uid.$member}{'position'}  = $usercheck{'position'};
			&UserAccount($member, "update");
		}
		if (!$usercheck{'position'}) { $usercheck{'position'} = &MemberPostGroup($usercheck{'postcount'}); }
		$regtime = stringtotime($usercheck{'regdate'});
		$memberlist{$member} = $regtime ? sprintf("%010d", $regtime) : stringtotime($forumstart);
		$memberinf{$member}  = qq~$usercheck{'realname'}\|$usercheck{'email'}\|$usercheck{'position'}\|$usercheck{'postcount'}\|${$uid.$member}{'addgroups'}~;

		undef %{$uid.$member} if ($username ne $member);
		last if time > $begin_time + $maxtime;
	}
	
	# Save what we've rebuilt so far
	fopen(MEMBERLIST, ">>$memberdir/memberlist.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberlist.txt.rebuild", 1);
#	print MEMBERLIST map {"$_\t$memberlist{$_}\n"} keys %memberlist;
	foreach (keys %memberlist) {print MEMBERLIST "$_\t$memberlist{$_}\n"};
	fclose(MEMBERLIST);

	fopen(MEMBERINFO, ">>$memberdir/memberinfo.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberinfo.txt.rebuild", 1);
#	print MEMBERINFO map {"$_\t$memberinf{$_}\n"} keys %memberinf;
	foreach (keys %memberinf) {print MEMBERINFO "$_\t$memberinf{$_}\n"};
	fclose(MEMBERINFO);

	fopen(MEMBERREST, ">$memberdir/memberrest.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberrest.txt.rebuild", 1);
#	print MEMBERREST map {"$_\n"} @contents;
	foreach (@contents) {print MEMBERREST "$_\n"};
	fclose(MEMBERREST);


	# See if we're completely done
	if(! @contents) {
	%memberlist=();
		# Sort memberlist.txt
		fopen(MEMBERLIST, "$memberdir/memberlist.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberlist.txt", 1);
		my %memberlist = map {split(/\t/, $_)} <MEMBERLIST>;
		fclose(MEMBERLIST);
		fopen(MEMBERLIST, ">$memberdir/memberlist.txt.rebuild") || &fatal_error('cannot_open', "$memberdir/memberlist.txt", 1);
#		print MEMBERLIST map {"$_\t$memberlist{$_}"} sort {$memberlist{$a} <=> $memberlist{$b}} keys %memberlist;
		foreach (sort {$memberlist{$a} <=> $memberlist{$b}} keys %memberlist) {print MEMBERLIST "$_\t$memberlist{$_}"};
		fclose(MEMBERLIST);

		# Move the updated copy back
		rename("$memberdir/memberlist.txt.rebuild", "$memberdir/memberlist.txt");
		rename("$memberdir/memberinfo.txt.rebuild", "$memberdir/memberinfo.txt");
		unlink("$memberdir/memberrest.txt.rebuild");
		unlink("$memberdir/membercalc.txt.rebuild");

		$regcounter = &MembershipCountTotal();
		$yymain .= qq~<b>$admin_txt{'594'} $regcounter $admin_txt{'594a'}</b>~;
		$yytitle     = "$admin_txt{'593'}";
		$action_area = "rebuildmemlist";
		&AdminTemplate();
	}
	# Or prepare to continue looping
	else {
		$restuser = @contents;

		$run_time = int(time-$start_time);
		$run_time = 1 if !$run_time;
		$time_left = int($restuser/(($sumuser-$restuser)/$run_time));

		$hour= int($run_time/3600);
		$min = int(($run_time-$hour*3600)/60);
		$sec = $run_time - $hour*3600 - $min*60;
		$hour = "0$hour" if $hour<10; $min = "0$min" if $min<10; $sec = "0$sec" if $sec<10;

		$run_time = "$hour:$min:$sec";

		$hour= int($time_left/3600);
		$min = int(($time_left-$hour*3600)/60);
		$sec = $time_left - $hour*3600 - $min*60;
		$hour = "0$hour" if $hour<10; $min = "0$min" if $min<10; $sec = "0$sec" if $sec<10;

		$time_left = "$hour:$min:$sec";

		$yymain .= qq~
<br />
$rebuild_txt{'1'}
<br />
$rebuild_txt{'7'} $maxtime $rebuild_txt{'8'}
<br /><br />
$rebuild_txt{'11'} $sumuser
<br />
$rebuild_txt{'12'} $restuser
<br />
<br />
$rebuild_txt{'9'} $run_time
<br />
$rebuild_txt{'10'} $time_left
<br />
<br />
<div id="memcontinued">
$rebuild_txt{'2'} <a href="$adminurl?action=rebuildmemlist" onclick="clearMeminfo();">$rebuild_txt{'3'}</a>
</div>
<script type="text/javascript" language="JavaScript">
<!--
	var convtext = "$rebuild_txt{'4'}";
	function clearMeminfo() {
		document.getElementById("memcontinued").innerHTML = convtext;
	}

	function membtick() {
		clearMeminfo();
		location.href="$adminurl?action=rebuildmemlist";
	}

setTimeout("membtick()", 1000)
// -->
</script>
~;
	&AdminTemplate();
	}
}
</replace>

<search for>
sub RebuildMemHistory {
	&is_admin_or_gmod;
	opendir("MEMBSDIR", $memberdir);
	@memlogs = grep { /\.rlog$/ } readdir(MEMBSDIR);
	closedir("MEMBSDIR");
	foreach $recfile (@memlogs) {
		chomp $recfile;
		unlink "$memberdir/$recfile";
	}

	opendir("BOARDSDIR", $boardsdir);
	@messages = grep { /\.txt$/ } readdir(BOARDSDIR);
	closedir("BOARDSDIR");

	foreach $file (@messages) {
		chomp $file;
		($foundfile, $ext) = split(/\./, $file);
		fopen("BRDFILE", "$boardsdir/$foundfile.txt");
		@messagefile = <BRDFILE>;
		fclose("BRDFILE");
		foreach my $line (@messagefile) {
			chomp $line;
			my ($thread, undef) = split(/\|/, $line, 2);
			if (-e "$datadir/$thread.txt") {
				fopen("MSGFILE", "$datadir/$thread.txt");
				@messagelines = <MSGFILE>;
				fclose("MSGFILE");
				foreach my $msgline (@messagelines) {
					chomp $msgline;
					my (undef, undef, undef, undef, $recuser, undef) = split(/\|/, $msgline, 6);
					if($username ne "Guest") { &writereclog($thread, $recuser); }
				}
			}
		}
	}

	$yymain .= qq~<b>$admin_txt{'598'}</b>~;
	$yytitle     = "$admin_txt{'597'}";
	$action_area = "rebuildmemhist";
	&AdminTemplate;
	exit;
}
</search for>

<replace>
sub RebuildMemHistory {
	my (@contents,$begin_time,$maxtime,$start_time,$timeleft,$hour,$min,$sec,$sumtopic,$resttopic);

	# Security
	&is_admin_or_gmod;

	# Set up the multi-step action
	$maxtime = 30; # Time in seconds to spend
	$begin_time = CORE::time;

	if (-e "$datadir/topicrest.txt.rebuild" ) {
		fopen(TOPICREST, "$datadir/topicrest.txt.rebuild") || &fatal_error('cannot_open', "$datadir/topicrest.txt.rebuild", 1);
		@contents = <TOPICREST>;
		fclose(TOPICREST);
		chomp @contents;

		fopen(TOPICCALC, "$datadir/topiccalc.txt.rebuild") || &fatal_error('cannot_open', "$datadir/topiccalc.txt.rebuild", 1);
		$start_time = <TOPICCALC>;
		$sumtopic = <TOPICCALC>;
		fclose(TOPICCALC);
		chomp ($begin_time,$sumtopic);
	}

	if (! @contents) {
		# Delete all rlog
		opendir(MEMBERS, $memberdir) || die "$txt{'230'} ($memberdir) :: $!";
		@contents = grep { /\.rlog$/ } readdir(MEMBERS);
		closedir(MEMBERS);
		foreach $recfile (@contents) {
			chomp $recfile;
			unlink "$memberdir/$recfile";
		}

		# Get the thread list
		opendir(TXT, $datadir);
		@contents = grep { /^\d{9,10}\.txt$/ } readdir(TXT);
		closedir(TXT);

		fopen(TOPICREST, ">$datadir/topicrest.txt.rebuild") || &fatal_error('cannot_open', "$datadir/topicrest.txt.rebuild", 1);
		foreach my $topic (@contents) {
			chomp $topic;
			$topic =~ s/\.txt$//;
			print TOPIC "$topic\n" if $topic;
		}		
		fclose(TOPICREST);

		$sumtopic = @contents;
		$start_time = $begin_time;
		fopen(TOPICCALC, ">$datadir/topiccalc.txt.rebuild") || &fatal_error('cannot_open', "$datadir/topiccalc.txt.rebuild", 1);
		print TOPICCALC "$start_time\n";
		print TOPICCALC "$sumtopic\n";
		fclose(TOPICCALC);

		$begin_time = +$maxtime; # only first step
	}

	# Loop through each -rest- topic
	while (@contents) {
		$topic = pop @contents;
		chomp $topic;

		my %curtopic=();

		fopen(TOPIC, "$datadir/$topic.txt");
		my @topic = <TOPIC>;
		fclose(TOPIC);

		foreach my $line (@topic) {
			my (undef, undef, undef, undef, $user, undef) = split(/\|/, $line, 6);
			if($user ne 'Guest') {
				$curtopic{$user} ||= 0;
				$curtopic{$user}++;
			}	
		}

		foreach my $user (keys %curtopic ) {
			if ( -e "$memberdir/$user.vars") { 
				fopen(HIST, ">>$memberdir/$user.rlog");
				print HIST "$topic\t$curtopic{$user}\n";
				fclose(HIST);
			}
		}

		last if time > $begin_time + $maxtime;
	}

	fopen(TOPICREST, ">$datadir/topicrest.txt.rebuild") || &fatal_error('cannot_open', "$datadir/topicrest.txt.rebuild", 1);
#	print TOPICREST map {"$_\n"} @contents;
	foreach (@contents) {print TOPICREST "$_\n"};
	fclose(TOPICREST);

	# See if we're completely done
	if(! @contents) {
		unlink("$datadir/topicrest.txt.rebuild");
		unlink("$datadir/topiccalc.txt.rebuild");

		$yymain .= qq~<b>$admin_txt{'598'}</b>~;
		$action_area = "rebuildmemhist";
		&AdminTemplate();
	}
	# Or prepare to continue looping
	else {
		$resttopic = @contents;

		$run_time = int(time-$start_time);
		$run_time = 1 if !$run_time;
		$time_left = int($resttopic/(($sumtopic-$resttopic)/$run_time));

		$hour= int($run_time/3600);
		$min = int(($run_time-$hour*3600)/60);
		$sec = $run_time - $hour*3600 - $min*60;
		$hour = "0$hour" if $hour<10; $min = "0$min" if $min<10; $sec = "0$sec" if $sec<10;

		$run_time = "$hour:$min:$sec";

		$hour= int($time_left/3600);
		$min = int(($time_left-$hour*3600)/60);
		$sec = $time_left - $hour*3600 - $min*60;
		$hour = "0$hour" if $hour<10; $min = "0$min" if $min<10; $sec = "0$sec" if $sec<10;

		$time_left = "$hour:$min:$sec";

		$yymain .= qq~
<br />
$rebuild_txt{'1'}
<br />
$rebuild_txt{'7'} $maxtime $rebuild_txt{'8'}
<br /><br />
$rebuild_txt{'13'} $sumtopic
<br />
$rebuild_txt{'14'} $resttopic
<br />
<br />
$rebuild_txt{'9'} $run_time
<br />
$rebuild_txt{'10'} $time_left
<br />
<br />
<div id="memcontinued">
$rebuild_txt{'2'} <a href="$adminurl?action=rebuildmemhist" onclick="clearMeminfo();">$rebuild_txt{'3'}</a>
</div>
<script type="text/javascript" language="JavaScript">
<!--
	var convtext = "$rebuild_txt{'4'}";
	function clearMeminfo() {
		document.getElementById("memcontinued").innerHTML = convtext;
	}

	function membtick() {
		clearMeminfo();
		location.href="$adminurl?action=rebuildmemhist";
	}

setTimeout("membtick()", 1000)
// -->
</script>
~;
	&AdminTemplate();
	}
}
</replace>

